#include <pspkernel.h>
#include <pspsdk.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <pspsysevent.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "libmenu.h"

#include "thread.h"
#include "common.h"
#include "color.h"
#include "conf.h"

PSP_MODULE_INFO("freestop", PSP_MODULE_KERNEL, 1, 1);

// inipϐ ini̍ڕKv
#define INI_PATH "/freestop.ini"
#define CONF_NUM 15
INI_Key conf[CONF_NUM];

char iniPath[128];

u32 stopkey = 0;
u32 closekey = 0;
u32 exitkey = 0;
bool Japanese = false;
bool English = false;
bool NoDisplay = false;
bool ResetOn = false;
bool BrightOn = false;
bool Bright0 = false;
bool BeforeTime  = false;
bool BeforeVol  = false;
bool BeforeBattery  = false;
bool AfterTime  = false;
bool AfterVol  = false;
bool AfterBattery  = false;

//print
char printBattery[64];
char printVolInfo[64];
char printTime[512];
char printVolGauge[64];


enum
{
	NoAction
};

enum
{
	LIBM_TCMD_SUSPEND	,	//Xbh~
	LIBM_TCMD_RESUME	,	//XbhĊJ
	LIBM_TCMD_DUMP		,	//Xbh~EĊJׂ̃Z[tXg
	LIBM_TCMD_GET		,	//Xbh̒~EĊJԂ擾
};


char str[512];
static libmOpt opt;

//vOC X^bNɃACeϐu
MenuContext	Context;
static MenuItem item_list[ITEM_COUNT];

int beforebright;

//vg^Cv錾
int threadMain(SceSize args, void *argp);
int module_start(SceSize args, void *argp);
int module_stop(SceSize args, void *argp);
void MenuCreate();
int sceDmacplusLcdcSetBaseAddrPatched(void *baseaddr);


void MenuCreate()
{
	//j[ ACe瓮ImۂȂݒɂ
	memset(&opt,0,sizeof(opt));
	opt.type		= LIBM_OPT_LIST;
	opt.list.val	= item_list;
	opt.list.size 	= sizeof(item_list);
	
	libmSetOpt(&Context,&opt);
	
	//j[p̊ePadݒ
		
	//\ HOME
	Context.HotKey.Show				= stopkey;
	//߂ HOME
	Context.HotKey.Back				= closekey;
	//I ~
	Context.HotKey.Select			= PSP_CTRL_NOTE | PSP_CTRL_START | PSP_CTRL_LTRIGGER;
	
	// 
	Context.HotKey.Up				= PSP_CTRL_UP;
	// 
	Context.HotKey.Down				= PSP_CTRL_DOWN;
	// 
	Context.HotKey.Left				= PSP_CTRL_LEFT;
	//E
	Context.HotKey.Right				= PSP_CTRL_RIGHT;
	
	//j[^Cv́uS̕\v
	Context.MenuInfo.Type 			= LIBM_VIEW_ALL;
	//ACeŏ㕔E֗玩Ń^[
	Context.MenuInfo.AutoReturn		= true;
		
	//ANeBuȍڂ̃tHgFAwiF
	Context.Color.Active_Font		= RED;
	Context.Color.Active_Back		= BLACK;
		
	//ANeBuȍڂ̃tHgFAwiF
	Context.Color.Normal_Font		= RED;
	Context.Color.Normal_Back		= BLACK;
		
	//s
	Context.MenuInfo.Lines	= 0;
	
	MenuItem* MAIN = libmAddItem(&Context,NULL,libmCreateSpacer(&opt,""),Invalid,Invalid,NoAction,0);

	//ANeBuACe lݒ
	libmSetActive( &Context ,MAIN);
}

//vOCȊȎXbh~EĊJ
int libmExecTCmd( int cmd )
{
	static int thid_status = LIBM_TRESUME;
	static bool thid_IsDump = false;
	static bool this_IsBusy = false;
	
	static int thid_list_first[MAX_NUMBER_OF_THREADS];
	static int thid_count_first;
	
	static int thid_list_Current[MAX_NUMBER_OF_THREADS];
	static int thid_count_Current;
	
	if( cmd ==  LIBM_TCMD_DUMP )
	{
		thid_IsDump = sceKernelGetThreadmanIdList( SCE_KERNEL_TMID_Thread, thid_list_first, MAX_NUMBER_OF_THREADS, &thid_count_first ) >= 0;
		
		return thid_IsDump;
	}
	else if( (cmd == LIBM_TCMD_SUSPEND || cmd == LIBM_TCMD_RESUME) && thid_IsDump && cmd != thid_status && !this_IsBusy )
	{
		thid_status = cmd;
		this_IsBusy = true;
		
		int i, j;
		int (*func)(SceUID) =  ( cmd == LIBM_TCMD_SUSPEND ? sceKernelSuspendThread : sceKernelResumeThread );
		SceKernelThreadInfo thinfo;
		
		
		if( cmd == LIBM_TCMD_SUSPEND )
		{
			//~
			
			int Current_id	= sceKernelGetThreadId();
			
			//݂̃XbhXg
			if( sceKernelGetThreadmanIdList( SCE_KERNEL_TMID_Thread, thid_list_Current, MAX_NUMBER_OF_THREADS, &thid_count_Current ) < 0 )
			{
				//݂̃XbhXg擾s
				this_IsBusy = false;
				return 0;
			}
			
			
			//݂̃XbhꗗƁAvOCNɃ_vZ[tXgr
			//Z[tXgƌXbhɈv̂͑ΏۊO
			for( i = 0; i < thid_count_Current; i++ )
			{
				memset(&thinfo, 0, sizeof(SceKernelThreadInfo));
				thinfo.size = sizeof(SceKernelThreadInfo);
				sceKernelReferThreadStatus(thid_list_Current[i], &thinfo);
				
				if
				(
				//	( strcasecmp( "SceImpose",thinfo.name) == 0 )
				//||
					( thinfo.attr & 0x100000 ) == 0x100000
				||
					( thid_list_Current[i] == Current_id )
				)
				{
					thid_list_Current[i] = 0;
					continue;
				}
				
				for( j = 0; j < thid_count_first; j++ )
				{
					if( thid_list_Current[i] == thid_list_first[j] )
					{
						thid_list_Current[i] = 0;
						break;
					}
				}
			}
		}
		
		
		//ŏIIȌ݂̃XbhXgɂXbh֒~EĊJ̑
		for( i = 0; i < thid_count_Current; i++ )
		{
			if( thid_list_Current[i] ) ( func )( thid_list_Current[i] );
		}
		
		this_IsBusy = false;
		
		return 1;
	}
	else if( cmd == LIBM_TCMD_GET )
	{
		return thid_status;
	}
	
	return 0;
}


int threadPrint(SceSize args, void *argp){
	while(1){
			printMenu();
		sceKernelDelayThread( 1000 );
	}
return 0;
}

int Callback_Suspend(int ev_id, char *ev_name, void *param, int *result)
{
	// Ԃl 0 ł͂Ȃ -1 ԂƁAX[v𖳌ł
	
	// X[v
	if( ev_id == PSP_SYSEVENT_SUSPEND_QUERY && libmExecTCmd(LIBM_TCMD_GET) == LIBM_TSUSPEND )
	{
		libmExecTCmd( LIBM_TCMD_RESUME );
		Context.IsOpen = false;
	}
	
	return 0;
}

//Main
int threadMain(SceSize args, void *argp)
{			
	//ւ悭Ȃorz
	while(1){
		if(
			sceKernelFindModuleByName("sceKernelLibrary") &&
			sceKernelFindModuleByName("sceIOFileManager") &&
			sceKernelFindModuleByName("sceController_Service") &&
			sceKernelFindModuleByName("sceDisplay_Service") &&
			sceKernelFindModuleByName("sceSystemMemoryManager")
		)
			break;

		sceKernelDelayThread(1000000);
	}
	
	if(BrightOn == false){
	libmPrintXY(187,114,BLACK,BLACK,"");
	}else{
	sceDisplayGetBrightness(&beforebright,0);
	}
	
	if(Bright0 == false){
	libmPrintXY(187,114,BLACK,BLACK,"");
	}else{
	sceDisplayGetBrightness(&beforebright,0);
	}
	
	PspSysEventHandler events;
		
	SceCtrlData pad;
	MenuParams* Params;
	
	events.size			= 0x40;
	events.name			= "MSE_Suspend";
	events.type_mask	= 0x0000FF00;
	events.handler		= Callback_Suspend;
	
	sceKernelRegisterSysEventHandler(&events);
			
	//j[쐬
	MenuCreate();
	
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
						
	//nȂǂ̏ꍇ
	SceUID print_thid = sceKernelCreateThread("PrintMenu", threadPrint, 1,0x3000, 0, NULL);
	if(threadInfo >= 0)sceKernelStartThread(print_thid, args, argp);

	while( 1 )
	{
	   	sceCtrlPeekBufferPositive(&pad, 1);
		
		//Key͂nāAj[̓𒲂ׂiʂ𓾂j
		Params = libmGetHandle(&Context, &pad);
		if(Params->Action == Menu_Close)
		{	
			sceKernelDelayThread(100000);
			Suspend_Resume_Threads(1);
			if(BrightOn == false){
			libmPrintXY(187,114,BLACK,BLACK,"");
			}else{		
			sceDisplaySetBrightness(beforebright,0);
			}
			if(Bright0 == false){
			libmPrintXY(187,114,BLACK,BLACK,"");
			}else{		
			sceDisplaySetBrightness(beforebright,0);
			}
		}		
		
		//0.001b҂		
		sceKernelDelayThread(1000);
	}
	
	return sceKernelExitDeleteThread( 0 );
}

int threadInfo(SceSize args, void *argp)
{
 while(1){
	int i;
	int flag1;

	getInfo();
		
	//[d܂ő҂
	flag1 = scePowerIsPowerOnline();
	

		//ʕ\
		sprintf(printVolInfo,"%2d",volume);
		sprintf(printVolGauge," ");

		for(i=0; i<volume; i++){
			strcat( printVolGauge,"b");
		}
		for(; i<30; i++){
			strcat( printVolGauge,"E");
		}
				
		//obe[cʕ\
		if(flag1 == 0){
			sprintf(printBattery,"  %3d%%(%d:%02d)   ",btryLifeP,btryH,btryM);
		}
		else if(flag1 == 1)
		{
			sprintf(printBattery,"  Charging Now ");		
		}
		
			//ԕ\
			sprintf(printTime," %2d:%02d:%02d    ",tick_time.hour,tick_time.minutes,tick_time.seconds);
							
		sceKernelDelayThread(100 * 1000);
		//0.1bfBC
}
  return 0;
}



void printMenu(void)
{		
	SceCtrlData pad;
	sceCtrlPeekBufferPositive(&pad, 1);
		
	if(libmInitBuffers(0,PSP_DISPLAY_SETBUF_NEXTFRAME)){	
	if(BeforeTime == false){
	libmPrintXY(0,264,GREEN,0,"");
	}else{
	libmPrintXY(0,264,GREEN,0,printTime);
	}
						
	if(BeforeVol == false){
	libmPrintXY(0,264,GREEN,0,"");
	}else{
	libmPrintXY(112,264,GREEN,0,printVolGauge);
	libmPrintXY(98,264,GREEN,0,printVolInfo);
	}
			
	if(BeforeBattery == false){
	libmPrintXY(0,264,GREEN,0,"");
	}else{
	libmPrintXY(360,264,GREEN,0,printBattery);
	}
	
	if( libmIsOpen(&Context)){		
	
			if(AfterTime == false){
			libmPrintXY(0,264,GREEN,0,"");
			}else{
			libmPrintXY(0,264,WHITE,BLACK,printTime);
			}
			
			if(AfterVol == false){
			libmPrintXY(0,264,GREEN,0,"");
			}else{
			libmPrintXY(98,264,WHITE,BLACK,printVolInfo);
			libmPrintXY(112,264,WHITE,BLACK,printVolGauge);
			}
						
			if(AfterBattery == false){
			libmPrintXY(0,264,GREEN,0,"");
			}else{
			libmPrintXY(360,264,WHITE,BLACK,printBattery);
			}
			
			if(BrightOn == false){
			libmPrintXY(187,114,BLACK,BLACK,"");
			}else{
			sceDisplaySetBrightness(45,0);
			}
			
			if(Bright0 == false){
			libmPrintXY(187,114,BLACK,BLACK,"");
			}else{		
			sceDisplaySetBrightness(0,0);
			}
			
			if(Japanese == false){
			libmPrintXY(0,264,GREEN,0,"");
			}else{
			libmPrintXY(187,114,BLACK,BLACK,"...............");
			libmPrintXY(187,126,BLACK,BLACK,"...............");
			libmPrintXY(275,120,BLACK,BLACK,"..");
			libmPrintXY(187,120,BLACK,BLACK,"..");
			libmPrintXY(195,120,WHITE,BLACK,"     ~    ");
			libmRender(&Context,140,110,str,256);
			Suspend_Resume_Threads(0);
			}
			
			if(English == false){
			libmPrintXY(0,264,GREEN,0,"");
			}else{
			libmPrintXY(187,114,BLACK,BLACK,"...............");
			libmPrintXY(187,126,BLACK,BLACK,"...............");
			libmPrintXY(275,120,BLACK,BLACK,"..");
			libmPrintXY(187,120,BLACK,BLACK,"..");
			libmPrintXY(195,120,WHITE,BLACK,"   Stopping   ");
			libmRender(&Context,140,110,str,256);
			Suspend_Resume_Threads(0);
			}
			
			if(NoDisplay == false){
			libmPrintXY(0,264,GREEN,0,"");
			}else{
			libmRender(&Context,140,110,str,256);
			Suspend_Resume_Threads(0);
			}
			
			if (pad.Buttons & PSP_CTRL_HOME){
			Suspend_Resume_Threads(1);
			Context.IsOpen = false;
			}
			
			if(ResetOn == false){
			libmPrintXY(187,114,BLACK,BLACK,"");
			}else{
			
				if ( (exitkey) && ((pad.Buttons& exitkey) == exitkey) ){
				Suspend_Resume_Threads(1);
				Context.IsOpen = false;
				
				if(BrightOn == false){
				libmPrintXY(187,114,BLACK,BLACK,"");
				}else{
				sceDisplaySetBrightness(beforebright,0);
				}
				
				if(Bright0 == false){
				libmPrintXY(187,114,BLACK,BLACK,"");
				}else{		
				sceDisplaySetBrightness(beforebright,0);
				}
				sceKernelExitVSHVSH(0);
				}
			}
			sceDisplayWaitVblankStart();
		}	
	}	
}


int module_start(SceSize args, void *argp)
{	
	char *temp;

	//ǂݍinit@C̃pX
	strcpy(iniPath, argp);
	// ms0:/seplugins/foo.prxǂݍ(sꂽƂ), iniPath"ms0:/seplugins/foo.prx"Rs[
	temp = strrchr(iniPath, '/');
	// iniPatḧԌɂ '/' TÃ|C^[temp
	if( temp != NULL ) *temp = '\0';
	// temp == NULL'/'TȂƂ,܂ temp != NULL '/'TƂ
	// '/'EOS('\0')ɕςA܂iniPath"ms0:/seplugins"ƂȂ
	strcat(iniPath, INI_PATH);
	//iniPath̖"/***.ini"A܂܂iniPath"ms0:/seplugins/***.ini"ƂȂ	

	// init@C̓ǂݍ݂̉
	INI_Init_Key(conf);//(K{)

	INI_Add_Button(conf, "stopkey", &stopkey, PSP_CTRL_UP | PSP_CTRL_RTRIGGER | PSP_CTRL_LTRIGGER);
	INI_Add_Button(conf, "closekey", &closekey , PSP_CTRL_CROSS );
	INI_Add_Button(conf, "exitkey", &exitkey , PSP_CTRL_RTRIGGER | PSP_CTRL_START );
	INI_Add_Bool(conf, "Japanese", &Japanese, true );
	INI_Add_Bool(conf, "English", &English, false );
	INI_Add_Bool(conf, "NoDisplay", &NoDisplay, false );
	INI_Add_Bool(conf, "BeforeTime", &BeforeTime, false );
	INI_Add_Bool(conf, "BeforeVol", &BeforeVol, false );
	INI_Add_Bool(conf, "BeforeBattery", &BeforeBattery, false );
	INI_Add_Bool(conf, "AfterTime", &AfterTime, false );
	INI_Add_Bool(conf, "AfterVol", &AfterVol, false );
	INI_Add_Bool(conf, "AfterBattery", &AfterBattery, false );
	INI_Add_Bool(conf, "ResetOn", &ResetOn, false );
	INI_Add_Bool(conf, "BrightOn", &BrightOn, false );
	INI_Add_Bool(conf, "Bright0", &Bright0, false );
	
	// init@C̓ǂݍ
	if(INI_Read_Conf(iniPath, conf) == 1){
	// init@C֏
		INI_Write_Conf(iniPath, conf, "\r\n");
	}
	
	//NidResolve
	sceDmacplusLcdcSetBaseAddrReal		= (void *)FindProc("sceLowIO_Driver", "sceDmacplus_driver", GetSetBaseAddrNidDisp());

	//CXbh̃X^bNTCYACeXg̕ϐTCY ₵ĂKv
	SceUID main_thid = sceKernelCreateThread("Main", threadMain, 16,0x3000, 0, NULL);
	if(main_thid >= 0)sceKernelStartThread(main_thid, args, argp);
	
	//擾XbhJn
	SceUID info_thid = sceKernelCreateThread("GetInfo", threadInfo, 16,0x3000, 0, NULL);
	if(threadInfo >= 0)sceKernelStartThread(info_thid, args, argp);	
	
	//pb`Ȃ
	u32 orgaddr = FindProc("sceDisplay_Service", "sceDisplay", 0x289D82FE);
	sceDisplaySetFrameBuf_Real = (void *)orgaddr;
	
	//݂̓擾
	Get_FirstThreads();

    return 0;
}


int module_stop(SceSize args, void *argp)
{
    return 0;
}

